"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Grid = _interopRequireDefault(require("@mui/material/Grid"));

var _Checkbox = _interopRequireDefault(require("@mui/material/Checkbox"));

var _FormControlLabel = _interopRequireDefault(require("@mui/material/FormControlLabel"));

var _FormLabel = _interopRequireDefault(require("@mui/material/FormLabel"));

var _FormGroup = _interopRequireDefault(require("@mui/material/FormGroup"));

var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));

var _FormHelperText = _interopRequireDefault(require("@mui/material/FormHelperText"));

var _multipleChoiceList = _interopRequireDefault(require("@data-driven-forms/common/multiple-choice-list"));

var _validationError = require("../validation-error/validation-error");

var _excluded = ["label", "isDisabled"],
    _excluded2 = ["initialValue", "isRequired", "isReadOnly", "helperText", "validate", "isDisabled", "component"],
    _excluded3 = ["FormControlProps", "FormLabelProps", "FormGroupProps", "FormHelperTextProps", "FormFieldGridProps", "FormControlLabelProps", "CheckboxProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CheckboxContext = /*#__PURE__*/(0, _react.createContext)({});

var FinalCheckbox = function FinalCheckbox(_ref) {
  var label = _ref.label,
      _isDisabled = _ref.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);

  var _useContext = (0, _react.useContext)(CheckboxContext),
      FormControlLabelProps = _useContext.FormControlLabelProps,
      CheckboxProps = _useContext.CheckboxProps,
      _useContext$props = _useContext.props,
      initialValue = _useContext$props.initialValue,
      isRequired = _useContext$props.isRequired,
      isReadOnly = _useContext$props.isReadOnly,
      helperText = _useContext$props.helperText,
      validate = _useContext$props.validate,
      isDisabled = _useContext$props.isDisabled,
      component = _useContext$props.component,
      props = (0, _objectWithoutProperties2["default"])(_useContext$props, _excluded2);

  return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({}, FormControlLabelProps, {
    control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({}, rest, props, CheckboxProps, {
      disabled: isDisabled
    }), label),
    label: label
  }));
};

var Wrapper = function Wrapper(_ref2) {
  var label = _ref2.label,
      isRequired = _ref2.isRequired,
      children = _ref2.children,
      meta = _ref2.meta,
      validateOnMount = _ref2.validateOnMount,
      helperText = _ref2.helperText,
      description = _ref2.description;
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);

  var _useContext2 = (0, _react.useContext)(CheckboxContext),
      FormFieldGridProps = _useContext2.FormFieldGridProps,
      FormControlProps = _useContext2.FormControlProps,
      FormLabelProps = _useContext2.FormLabelProps,
      FormGroupProps = _useContext2.FormGroupProps,
      FormHelperTextProps = _useContext2.FormHelperTextProps;

  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    item: true,
    xs: 12
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], FormLabelProps, label), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], FormGroupProps, children), (invalid || helperText || description) && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, invalid || helperText || description)));
};

var MultipleChoiceList = function MultipleChoiceList(_ref3) {
  var _ref3$FormControlProp = _ref3.FormControlProps,
      FormControlProps = _ref3$FormControlProp === void 0 ? {} : _ref3$FormControlProp,
      _ref3$FormLabelProps = _ref3.FormLabelProps,
      FormLabelProps = _ref3$FormLabelProps === void 0 ? {} : _ref3$FormLabelProps,
      _ref3$FormGroupProps = _ref3.FormGroupProps,
      FormGroupProps = _ref3$FormGroupProps === void 0 ? {} : _ref3$FormGroupProps,
      _ref3$FormHelperTextP = _ref3.FormHelperTextProps,
      FormHelperTextProps = _ref3$FormHelperTextP === void 0 ? {} : _ref3$FormHelperTextP,
      _ref3$FormFieldGridPr = _ref3.FormFieldGridProps,
      FormFieldGridProps = _ref3$FormFieldGridPr === void 0 ? {} : _ref3$FormFieldGridPr,
      _ref3$FormControlLabe = _ref3.FormControlLabelProps,
      FormControlLabelProps = _ref3$FormControlLabe === void 0 ? {} : _ref3$FormControlLabe,
      _ref3$CheckboxProps = _ref3.CheckboxProps,
      CheckboxProps = _ref3$CheckboxProps === void 0 ? {} : _ref3$CheckboxProps,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(CheckboxContext.Provider, {
    value: {
      FormControlProps: FormControlProps,
      FormLabelProps: FormLabelProps,
      FormGroupProps: FormGroupProps,
      FormHelperTextProps: FormHelperTextProps,
      FormFieldGridProps: FormFieldGridProps,
      FormControlLabelProps: FormControlLabelProps,
      CheckboxProps: CheckboxProps,
      props: props
    }
  }, /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({}, props, {
    Wrapper: Wrapper,
    Checkbox: FinalCheckbox
  })));
};

var _default = MultipleChoiceList;
exports["default"] = _default;